//aviutil
#include <windows.h>
#include <vfw.h>
#include "input.h"
#include "avisynth.h"
#include "debug.h"


#define FOURCC_YUYV	mmioFOURCC('Y','U','Y','V')
#define FOURCC_YUY2	mmioFOURCC('Y','U','Y','2')
#define FOURCC_YVYU	mmioFOURCC('Y','V','Y','U')
#define FOURCC_UYVY	mmioFOURCC('U','Y','V','Y')
#define FOURCC_I420	mmioFOURCC('I','4','2','0')
#define FOURCC_IYUV	mmioFOURCC('I','Y','U','V')
#define FOURCC_YV12	mmioFOURCC('Y','V','1','2')
#define FOURCC_AVC1 mmioFOURCC('A','V','C','1')
#define FOURCC_avc1 mmioFOURCC('a','v','c','1')


//---------------------------------------------------------------------
//		̓vOC\̒`
//---------------------------------------------------------------------
INPUT_PLUGIN_TABLE input_plugin_table = {
	INPUT_PLUGIN_FLAG_VIDEO|INPUT_PLUGIN_FLAG_AUDIO,	//	tO
														//	INPUT_PLUGIN_FLAG_VIDEO	: 摜T|[g
														//	INPUT_PLUGIN_FLAG_AUDIO	: T|[g
	"(U)DirectShowSource",  							//	vOC̖O
	"All File (*.*)\0*.*\0",							//	̓t@CtB^
	"(U)DirectShowSource ver 0.1 By seraphy",			//	vOC̏
	func_init,											//	DLLJnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_exit,											//	DLLIɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_open,											//	̓t@CI[v֐ւ̃|C^
	func_close,											//	̓t@CN[Y֐ւ̃|C^
	func_info_get,										//	̓t@C̏擾֐ւ̃|C^
	func_read_video,									//	摜f[^ǂݍފ֐ւ̃|C^
	func_read_audio,									//	f[^ǂݍފ֐ւ̃|C^
	NULL,												//	L[t[ׂ֐ւ̃|C^ (NULLȂSăL[t[)
	NULL,												//	͐ݒ̃_CAOvꂽɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};


//---------------------------------------------------------------------
//		̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C INPUT_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetInputPluginTable( void ){
	return &input_plugin_table;
}

typedef struct {
	BYTE	*data;
	int		offset;	// JnTvʒu
	int		size;
	BOOL	b_full;
	BOOL	b_clr;
} AUDIO_BUFFER;
int AUDIO_BUFFER_SIZE = 0;

//---------------------------------------------------------------------
//		t@Cnh\
//---------------------------------------------------------------------
typedef struct {
	int					sampleCount;
	int					width;
	int					height;
	int					pitch;
	int					rate;
	int					scale;
	int					imageSize;
	DWORD				biCompression;
	int					bitsPerPixel;
} FILE_HANDLE_VIDEO;
typedef struct{
	int					samples;
	int					samplingRate;
	int					channels;
	int					bitsPerSample;
	int					blockAlign;
} FILE_HANDLE_AUDIO;

typedef struct {
	PClip				clip;
	int					flag;
	FILE_HANDLE_VIDEO	V;
	FILE_HANDLE_AUDIO	A;
	IScriptEnvironment	*_env;
	HINSTANCE			_handle;
} FILE_HANDLE;

#define FILE_HANDLE_FLAG_VIDEO		1
#define FILE_HANDLE_FLAG_AUDIO		2


typedef IScriptEnvironment *(__stdcall *FUNC_CreateScriptEnvironment)(int);
FUNC_CreateScriptEnvironment _CreateScriptEnvironment;


//---------------------------------------------------------------------
//		
//---------------------------------------------------------------------
BOOL func_init( void ){
	return TRUE;
}


//---------------------------------------------------------------------
//		I
//---------------------------------------------------------------------
BOOL func_exit( void ){
	return TRUE;
}


//---------------------------------------------------------------------
//		t@CI[v
//---------------------------------------------------------------------
INPUT_HANDLE func_open( LPSTR file ){
	FILE_HANDLE *fp = (FILE_HANDLE *)GlobalAlloc(GMEM_FIXED,sizeof(FILE_HANDLE));

	if( fp == NULL ) return NULL;
	ZeroMemory(fp,sizeof(FILE_HANDLE));

	// AviSynth
	fp->_handle = LoadLibrary("avisynth.dll");
	if(!fp->_handle)
		return NULL;

	_CreateScriptEnvironment = (FUNC_CreateScriptEnvironment)GetProcAddress(fp->_handle, "CreateScriptEnvironment");
	fp->_env = _CreateScriptEnvironment(AVISYNTH_INTERFACE_VERSION);

	if(!fp->_env->FunctionExists("DirectShowSource"))
		return NULL;

	//Init@C
	char iniFile[5120];
	char buf[512];

	// p[^
	float	prm_fps = 0;
	int		prm_convertFps = 0;
	char	prm_media[20];
	strcpy(prm_media, "YUY2");

	// g̃nhIni擾
	HMODULE hMe = GetModuleHandle("DirectShowSource.aui");
	if(GetModuleFileName(hMe, iniFile, sizeof(iniFile))!=NULL){
		strcpy(iniFile + strlen(iniFile) - 4, ".ini");

		GetPrivateProfileString("SETTING", "fps", "0", buf, sizeof(buf), iniFile);
		prm_fps = atof(buf);

		GetPrivateProfileString("SETTING", "convertFps", "0", buf, sizeof(buf), iniFile);
		prm_convertFps = atoi(buf);

		GetPrivateProfileString("SETTING", "pixel_type", "YUY2", buf, sizeof(buf), iniFile);
		strcpy(prm_media, buf);
	}
	
	bool convertFps = (prm_convertFps == 1) ? true : false;

	// Nbv̍쐬
	if(prm_fps > 1){
		AVSValue args[]	= { file, prm_fps, convertFps, prm_media };
		const char *arg_names[] = { 0, "fps", "convertFps", "pixel_type" };
		fp->clip = fp->_env->Invoke("DirectShowSource", AVSValue(args,4), arg_names).AsClip();
	} else {
		AVSValue args[]	= { file, prm_media };
		const char *arg_names[] = { 0, "pixel_type" };
		fp->clip = fp->_env->Invoke("DirectShowSource", AVSValue(args,2), arg_names).AsClip();
	}

	fp->flag = 0;
	VideoInfo vi = fp->clip->GetVideoInfo();

	if(vi.HasVideo()){
		fp->V.width			= vi.width;
		fp->V.height		= vi.height;
		fp->V.scale			= 1001;
		fp->V.rate			= int((double)vi.fps_numerator / (double)vi.fps_denominator * 1001.0 + 0.5);
		fp->V.sampleCount	= vi.num_frames;
		fp->V.bitsPerPixel	= vi.BitsPerPixel();
		fp->V.pitch			= fp->V.width * fp->V.bitsPerPixel / 8;
		switch (vi.pixel_type) {
			case vi.CS_YUY2:
				fp->V.biCompression = FOURCC_YUY2;
				break;
			case vi.CS_YV12:
				fp->V.biCompression = FOURCC_YV12;
				break;
			case vi.CS_I420:
				fp->V.biCompression = FOURCC_I420;
				break;
			default:
				fp->V.biCompression = BI_RGB;
				break;
		}

		fp->V.imageSize		= fp->V.width * fp->V.height * fp->V.bitsPerPixel / 8;

		fp->flag |= FILE_HANDLE_FLAG_VIDEO;
	}

	if(vi.HasAudio()){
		fp->A.samplingRate	= vi.audio_samples_per_second;
		fp->A.channels		= vi.nchannels;
		fp->A.bitsPerSample = vi.BytesPerAudioSample() * 8 / fp->A.channels;
		fp->A.blockAlign	= fp->A.channels * fp->A.bitsPerSample / 8;
		fp->A.samples		= vi.num_audio_samples;

		fp->flag |= FILE_HANDLE_FLAG_AUDIO;
	}

	return fp;
}


//---------------------------------------------------------------------
//		t@CN[Y
//---------------------------------------------------------------------
BOOL func_close( INPUT_HANDLE ih ){
	FILE_HANDLE *fp = (FILE_HANDLE *)ih;

	if( fp ) {

		fp->clip->~IClip();
		fp->_env->~IScriptEnvironment();
		FreeLibrary(fp->_handle);

		GlobalFree(fp);
	}
	return TRUE;
}


//---------------------------------------------------------------------
//		t@C̏
//---------------------------------------------------------------------
BOOL func_info_get( INPUT_HANDLE ih,INPUT_INFO *iip ){
	FILE_HANDLE *fp = (FILE_HANDLE *)ih;
	static BITMAPINFOHEADER bi;
	static WAVEFORMATEX wf;

	ZeroMemory(&bi, sizeof(bi));
	ZeroMemory(&wf, sizeof(wf));

	iip->flag = 0;

	// fẢ
	if( fp->flag & FILE_HANDLE_FLAG_VIDEO ) {
		bi.biWidth = fp->V.width;
		bi.biHeight = fp->V.height;
		bi.biPlanes = 1;
		bi.biBitCount = fp->V.bitsPerPixel;
		bi.biCompression = fp->V.biCompression;
		bi.biSizeImage = fp->V.imageSize;
		bi.biSize = sizeof(bi);

		iip->flag |= INPUT_INFO_FLAG_VIDEO;
		iip->rate = fp->V.rate;
		iip->scale = fp->V.scale;
		iip->n = fp->V.sampleCount;
		iip->format = &bi;
		iip->format_size = sizeof(bi);
		iip->handler = NULL;
	}

	if( fp->flag & FILE_HANDLE_FLAG_AUDIO ) {
		wf.wFormatTag = WAVE_FORMAT_PCM;
		wf.nChannels = fp->A.channels;
		wf.wBitsPerSample = fp->A.bitsPerSample;
		wf.nBlockAlign = fp->A.blockAlign;
		wf.nSamplesPerSec = fp->A.samplingRate;
		wf.nAvgBytesPerSec = wf.nSamplesPerSec * wf.nBlockAlign;
		wf.cbSize = 0;//sizeof(wf);

		iip->flag |= INPUT_INFO_FLAG_AUDIO;
		iip->audio_n = fp->A.samples;
		iip->audio_format = &wf;
		iip->audio_format_size = sizeof(WAVEFORMATEX);
	}

	return TRUE;
}

//---------------------------------------------------------------------
//		ǂݍ
//---------------------------------------------------------------------
int func_read_audio( INPUT_HANDLE ih,int start,int length, void *buf ){
	FILE_HANDLE *fp = (FILE_HANDLE *)ih;

	fp->clip->GetAudio(buf, (__int64)start, (__int64)length, fp->_env);
	return length;
}


//---------------------------------------------------------------------
//		摜ǂݍ
//---------------------------------------------------------------------
int func_read_video( INPUT_HANDLE ih,int frame,void *buf ){
	FILE_HANDLE *fp = (FILE_HANDLE *)ih;

	PVideoFrame pvf = fp->clip->GetFrame(frame, fp->_env);
	fp->_env->BitBlt((BYTE*)buf, fp->V.pitch, pvf->GetReadPtr(), pvf->GetPitch(), pvf->GetRowSize(), pvf->GetHeight());

	return fp->V.imageSize;
}

